SystemOrganization addCategory: #'MSK-OS-Interface'!

!NBExternalHandle methodsFor: '*MSK-OS-Interface' stamp: 'MartenFeldtmann 4/5/2013 16:42'!
asExternalFunctionParameter 

	^self ! !

!UndefinedObject methodsFor: '*MSK-OS-Interface' stamp: 'MartenFeldtmann 9/3/2012 22:03'!
asExternalFunctionParameter

	^nil! !

NBExternalStructureType subclass: #OSStructure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

Object subclass: #OSObject
	instanceVariableNames: 'reference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSObject class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/3/2012 21:07'!
address: externalLocation

	^super new 
		reference: externalLocation ;
		yourself ! !

!OSObject class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 8/28/2012 12:14'!
calloc

	^self calloc: 1! !

!OSObject class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/3/2012 21:03'!
calloc: numberOfElements

	^super new 
		reference: (NativeBoost allocate: (numberOfElements * self fixedSize) );
		yourself ! !

!OSObject class methodsFor: 'constants' stamp: 'MartenFeldtmann 8/28/2012 11:52'!
fixedSize
	"^<Integer> Returns the size of ONE element"
	
	^self subclassResponsibility ! !

!OSObject class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 8/28/2012 12:10'!
new

	^self new: 1! !

!OSObject class methodsFor: 'instance creation' stamp: 'MartenFeldtmann 9/3/2012 21:03'!
new: numberOfElements

	^super new 
		reference: (ByteArray new: numberOfElements * self fixedSize );
		yourself ! !

!OSObject methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/11/2012 15:41'!
asExternalFunctionParameter
	"^<ByteArray | NBExternalAddress> Returns the actual structure holding the values"

	^ self reference! !

!OSObject methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/11/2012 15:42'!
asParameter

	^self asExternalFunctionParameter! !

!OSObject methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 21:02'!
reference
	^ reference! !

!OSObject methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 21:02'!
reference: anObject
	reference := anObject! !

OSObject subclass: #OSPtr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSPtr subclass: #OSBaseType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSBaseType subclass: #OSCharacter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSCharacter subclass: #OSChar8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSChar8 subclass: #OSStringZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSStringZ methodsFor: 'conversion' stamp: 'MartenFeldtmann 9/3/2012 22:08'!
asString
  "^<String> Converts a null terminated string located in non-Smalltalk memory to an instance of String"

	| stream index aChar aValue |
	
	"seems to be a boring source code - I expect to have a much better one, when
	I understand the details in the virtual machine much better"
	(self reference isNil or: [ self reference  isNull ]) ifTrue:[ ^String new ].
	
	stream := WriteStream with: String new.
	index := 0.
	
	[ (aValue := self reference byteAt: index) > 0] whileTrue:[
		stream nextPut: (Character value: aValue).
		index := index + 1.
	].

  	^stream contents
	
	
	
	
	
	! !

OSBaseType subclass: #OSFloat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSFloat subclass: #OSFloat32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSFloat subclass: #OSFloat64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSBaseType subclass: #OSInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

OSInteger subclass: #OSInt16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSInt16 class methodsFor: 'constants' stamp: 'MartenFeldtmann 9/3/2012 21:06'!
fixedSize

	^2! !

OSInteger subclass: #OSInt32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSInt32 class methodsFor: 'constants' stamp: 'MartenFeldtmann 8/28/2012 11:54'!
fixedSize

	^4! !

!OSInt32 methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 21:04'!
at: zeroBasedIndexInteger 

	^self reference nbLongAt: (zeroBasedIndexInteger * self class fixedSize + 1)! !

!OSInt32 methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 21:04'!
at: zeroBasedIndexInteger put: anInteger

	^self reference nbLongAt: ((zeroBasedIndexInteger * self class fixedSize) + 1) at: anInteger! !

OSInteger subclass: #OSInt64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSInt64 class methodsFor: 'constants' stamp: 'MartenFeldtmann 9/4/2012 10:47'!
fixedSize

	^8! !

OSInteger subclass: #OSInt8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSInt8 class methodsFor: 'constants' stamp: 'MartenFeldtmann 9/4/2012 10:47'!
fixedSize

	^1! !

OSInteger subclass: #OSUInt16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSUInt16 class methodsFor: 'constants' stamp: 'MartenFeldtmann 9/3/2012 21:06'!
fixedSize

	^2! !

OSInteger subclass: #OSUInt32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSUInt32 class methodsFor: 'constants' stamp: 'MartenFeldtmann 8/28/2012 11:54'!
fixedSize

	^4! !

!OSUInt32 methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/3/2012 21:04'!
at: zeroBasedIndexInteger 

	^self reference nbULongAt: ((zeroBasedIndexInteger * self class fixedSize) + 1)! !

!OSUInt32 methodsFor: 'accessing' stamp: 'MartenFeldtmann 9/11/2012 12:04'!
at: zeroBasedIndexInteger put: anInteger

	^self reference nbULongAt: ((zeroBasedIndexInteger * self class fixedSize) + 1) at: anInteger! !

OSInteger subclass: #OSUInt64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSUInt64 class methodsFor: 'constants' stamp: 'MartenFeldtmann 9/4/2012 10:48'!
fixedSize

	^8! !

OSInteger subclass: #OSUInt8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSUInt8 class methodsFor: 'constants' stamp: 'MartenFeldtmann 9/4/2012 10:47'!
fixedSize

	^1! !

!OSPtr methodsFor: 'accessing' stamp: 'MartenFeldtmann 8/28/2012 12:02'!
at: oneBasedIndex

	self subclassResponsibility ! !

!OSPtr methodsFor: 'accessing' stamp: 'MartenFeldtmann 8/28/2012 12:02'!
at: oneBasedIndex put: value

	self subclassResponsibility ! !

!OSPtr methodsFor: 'freeing' stamp: 'MartenFeldtmann 9/11/2012 15:40'!
free

	self reference free ! !

!OSPtr methodsFor: 'testing' stamp: 'MartenFeldtmann 9/8/2012 15:01'!
isNull

	^self reference isNil or: [ self reference isNull ]! !

!OSPtr methodsFor: 'testing' stamp: 'MartenFeldtmann 9/5/2012 15:16'!
notNull

	^self reference isNull not! !

OSPtr subclass: #OSVoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MSK-OS-Interface'!

!OSVoid class methodsFor: 'constants' stamp: 'MartenFeldtmann 8/28/2012 14:23'!
fixedSize

  ^nil! !

!Object methodsFor: '*MSK-OS-Interface' stamp: 'MartenFeldtmann 9/3/2012 22:42'!
asExternalFunctionParameter 

	^self! !
